'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-2a6e6244.js');
const index_esm_min = require('./index.esm.min-d07c5def.js');
const index_esm_min$1 = require('./index.esm.min-5be3f6d6.js');

const bpSdkAccumulationQuestionGroupCss = "[name='evanston_activity_inventory_percentage_total']{visibility:hidden}[name='evanston_activity_inventory_percentage_total']+bp-sdk-errors-container{display:none}";

let BpSdkAccumulationQuestionGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    /**
     * Answers
     */
    this.answers = [];
    /**
     * Warning message
     */
    this.warning = 'Percent of total operations must equal 100%';
    this.showAccumulatorWarning = false;
    this.showAccumulatorErrors = false;
    this.useExternal = false;
  }
  onAnswersChange(answers) {
    this.accumulator = (answers || []).find((answer) => { var _a; return ((_a = answer === null || answer === void 0 ? void 0 : answer.question) === null || _a === void 0 ? void 0 : _a.reference_type) === index_esm_min.u.Accumulator; });
  }
  onAccumulatorChange(accumulator) {
    const buffer = parseInt(accumulator === null || accumulator === void 0 ? void 0 : accumulator.value, 10);
    this.buffer = isNaN(buffer) ? undefined : buffer;
    this.showAccumulatorWarning = this.validateAccumulatorValue();
  }
  onAccumulatorErrorsChange({ detail }) {
    this.showAccumulatorErrors = detail.length > 0;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-accumulation-question-group');
    customElements.whenDefined('bp-sdk-external-accumulation-question-group').then(() => {
      this.useExternal = true;
    });
    this.onAnswersChange(this.answers);
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-accumulation-question-group", { answers: this.answers, label: this.label, labelledBy: this.labelledBy, warning: this.warning }));
  }
  shouldHideLabel(answer) {
    var _a, _b;
    return (((_a = answer === null || answer === void 0 ? void 0 : answer.question) === null || _a === void 0 ? void 0 : _a.field_type) === index_esm_min.t.CheckBox || ((_b = answer === null || answer === void 0 ? void 0 : answer.question) === null || _b === void 0 ? void 0 : _b.reference_type) === index_esm_min.u.Accumulator);
  }
  getAriaLabel(answer) {
    var _a;
    return ((_a = answer === null || answer === void 0 ? void 0 : answer.question) === null || _a === void 0 ? void 0 : _a.field_type) === index_esm_min.t.CheckBox ? answer.question.text : undefined;
  }
  validateAccumulatorValue() {
    var _a;
    if ((_a = this.accumulator) === null || _a === void 0 ? void 0 : _a.value) {
      return this.buffer < this.accumulator.question.min_value || this.buffer > this.accumulator.question.max_value;
    }
    return false;
  }
  renderInternal() {
    var _a;
    return (index.h("div", { class: "bp-sdk-accumulation-question-group__container" }, index.h("div", { class: "bp-sdk-accumulation-question-group__wrapper" }, index.h("div", { class: "bp-sdk-accumulation-question-set__header" }, index.h("bp-sdk-progress", { label: "Question group progress", value: this.buffer }), index.h("div", null, ((_a = this.accumulator) === null || _a === void 0 ? void 0 : _a.value) && (index.h("h2", { "aria-live": "assertive", class: "bp-sdk-accumulation-question-set__value" }, this.accumulator.value, "%")), this.showAccumulatorErrors && index.h("h4", { class: "bp-sdk-accumulation-question-set__error" }, this.warning), this.showAccumulatorWarning && !this.showAccumulatorErrors && (index.h("h4", { class: "bp-sdk-accumulation-question-set__warning" }, this.warning)))), this.answers.map((answer) => (index.h("bp-sdk-dynamic-input-redux-container", { class: index_esm_min$1.ix('', {
        'bp-sdk-indent': answer.question.reference_type === index_esm_min.u.Indent,
      }), answer: answer, shouldHideLabel: this.shouldHideLabel(answer), "aria-label": this.getAriaLabel(answer), isAccumulatorAnswer: answer.question.reference_type === index_esm_min.u.Accumulator }))))));
  }
  static get watchers() { return {
    "answers": ["onAnswersChange"],
    "accumulator": ["onAccumulatorChange"]
  }; }
};
BpSdkAccumulationQuestionGroup.style = bpSdkAccumulationQuestionGroupCss;

const bpSdkProgressCss = "";

let BpSdkProgress = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-progress');
    customElements.whenDefined('bp-sdk-external-progress').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return index.h("bp-sdk-external-progress", { label: this.label, value: this.value });
  }
  renderInternal() {
    return (index.h("div", { class: "bp-sdk-progress__container" }, index.h("progress", { class: "bp-sdk-progress__bar", value: this.value, "aria-label": this.label })));
  }
};
BpSdkProgress.style = bpSdkProgressCss;

exports.bp_sdk_accumulation_question_group = BpSdkAccumulationQuestionGroup;
exports.bp_sdk_progress = BpSdkProgress;
