import { Component, h, Prop, State } from '@stencil/core';
export class BpSdkPendingProcessContainer {
  constructor() {
    this.pendingProcesses = [];
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-pending-process-container');
    customElements.whenDefined('bp-sdk-external-pending-process-container').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-pending-process-container", { pendingProcesses: this.pendingProcesses });
  }
  renderInternal() {
    return h("div", { class: "bp-sdk-pending-process-container__container" },
      h("bp-sdk-pending-process", { pendingProcesses: this.pendingProcesses }));
  }
  static get is() { return "bp-sdk-pending-process-container"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-pending-process-container.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-pending-process-container.css"]
  }; }
  static get properties() { return {
    "pendingProcesses": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "IApplicationFormProcesses[]",
        "resolved": "IApplicationFormProcesses[]",
        "references": {
          "IApplicationFormProcesses": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "defaultValue": "[]"
    }
  }; }
  static get states() { return {
    "useExternal": {}
  }; }
}
