import { Component, h, Prop, State } from '@stencil/core';
export class BpSdkQuotePayment {
  constructor() {
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-payment');
    customElements.whenDefined('bp-sdk-external-quote-payment').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-payment", { quoteRequest: this.quoteRequest });
  }
  renderInternal() {
    return h("div", { class: "bp-sdk-quote-payment__container" });
  }
  static get is() { return "bp-sdk-quote-payment"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-quote-payment.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-quote-payment.css"]
  }; }
  static get properties() { return {
    "quoteRequest": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "IQuoteRequest",
        "resolved": "IQuoteRequest",
        "references": {
          "IQuoteRequest": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      }
    }
  }; }
  static get states() { return {
    "useExternal": {}
  }; }
}
