import { Component, h, Prop, State } from '@stencil/core';
export class BpSdkQuoteRequestTaxesAndFees {
  constructor() {
    /**
     * fees
     */
    this.fees = [];
    /**
     * taxes
     */
    this.taxes = [];
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-taxes-and-fees');
    customElements.whenDefined('bp-sdk-external-quote-request-taxes-and-fees').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-taxes-and-fees", { "disclaimer-html": this.disclaimerHtml, fees: this.fees, taxes: this.taxes });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-taxes-and-fees__container" },
      h("div", { class: "bp-sdk-quote-request-taxes-and-fees--subtotal" },
        h("div", null, "Taxes and fees included in your premium"),
        h("bp-sdk-quote-request-fees", { fees: this.taxes, description: 'taxes' }),
        h("bp-sdk-quote-request-fees", { fees: this.fees, description: 'fees' })),
      !!this.disclaimerHtml && (h("div", { class: "bp-sdk-quote-request-taxes-and-fees--disclaimer-container" },
        h("div", { class: "bp-sdk-quote-request-taxes-and-fees--disclaimer bp-sdk-quote-request--disclaimer", innerHTML: this.disclaimerHtml })))));
  }
  static get is() { return "bp-sdk-quote-request-taxes-and-fees"; }
  static get originalStyleUrls() { return {
    "$": ["./bp-sdk-quote-request-taxes-and-fees.css"]
  }; }
  static get styleUrls() { return {
    "$": ["bp-sdk-quote-request-taxes-and-fees.css"]
  }; }
  static get properties() { return {
    "disclaimerHtml": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string | undefined",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "disclaimer html"
      },
      "attribute": "disclaimer-html",
      "reflect": false
    },
    "fees": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "IQuotePrice[]",
        "resolved": "IQuotePrice[]",
        "references": {
          "IQuotePrice": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "fees"
      },
      "defaultValue": "[]"
    },
    "taxes": {
      "type": "unknown",
      "mutable": false,
      "complexType": {
        "original": "IQuotePrice[]",
        "resolved": "IQuotePrice[]",
        "references": {
          "IQuotePrice": {
            "location": "import",
            "path": "@boldpenguin/sdk-types"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "taxes"
      },
      "defaultValue": "[]"
    }
  }; }
  static get states() { return {
    "useExternal": {}
  }; }
}
