import { r as registerInstance, h } from './index-b4e0290f.js';
import { e as fx } from './index.esm.min-06482c89.js';

const bpSdkQuoteRequestFeesCss = "";

let BpSdkQuoteRequestFees = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    /**
     * list of fees to render
     */
    this.fees = [];
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-fees');
    customElements.whenDefined('bp-sdk-external-quote-request-fees').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-fees", { description: this.description, fees: this.fees });
  }
  renderInternal() {
    return (h("section", { class: "bp-sdk-quote-request-fees__container", "aria-description": this.description }, this.fees.map((fee) => (h("bp-sdk-quote-request-price", { description: fee.description, price: fee.amount })))));
  }
};
BpSdkQuoteRequestFees.style = bpSdkQuoteRequestFeesCss;

const bpSdkQuoteRequestPriceCss = "";

let BpSdkQuoteRequestPrice = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.descriptionId = fx(8);
    this.useExternal = false;
  }
  resetState() { }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-price');
    customElements.whenDefined('bp-sdk-external-quote-request-price').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-price", { description: this.description, price: this.price });
  }
  renderInternal() {
    return (h("div", { class: "bp-sdk-quote-request-price__container" }, h("span", { class: "bp-sdk-quote-request-price__description", id: this.descriptionId }, this.description), h("span", { class: "bp-sdk-quote-request-price__separator" }, ":"), h("span", { class: "bp-sdk-quote-request-price__amount", "aria-labelledby": this.descriptionId }, this.price)));
  }
};
BpSdkQuoteRequestPrice.style = bpSdkQuoteRequestPriceCss;

export { BpSdkQuoteRequestFees as bp_sdk_quote_request_fees, BpSdkQuoteRequestPrice as bp_sdk_quote_request_price };
