import { Event, EventEmitter } from '../../stencil-public-runtime';
import { IBusinessClassificationSelectorListItemComponent, IChoiceHighlight } from '@boldpenguin/sdk-types';
export declare class BpSdkBusinessClassificationSelectorListItem implements IBusinessClassificationSelectorListItemComponent {
  /**
   * Alias of choice
   */
  alias: string;
  /**
   * Value of choice
   */
  value: string;
  /**
   * List of highlight's
   */
  highlights: IChoiceHighlight[] | undefined;
  /**
   * Is choice selected
   */
  isSelected: boolean;
  /**
   * Should show explanation
   */
  showExplanation: boolean;
  /**
   * Confidence level
   */
  confidence: number;
  /**
   * Should show confidence
   */
  showConfidence: boolean;
  /**
   * Choice's id
   */
  choiceId: string;
  /**
   * Show detailed relevance chip
   */
  showDetailedRelevanceChip: boolean;
  /**
   * Is application form locked
   */
  locked: boolean;
  /**
   * Is best choice match
   */
  isBestMatch: boolean;
  useExternal: boolean;
  isExpanded: boolean;
  valueUpdate: EventEmitter<string[]>;
  componentWillLoad(): void;
  onSelection: (e: Event) => void;
  onKeyPress: (e: KeyboardEvent) => void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
