import { IChoice, IBusinessClassificationSelectorComponent } from '@boldpenguin/sdk-types';
export declare class BpSdkBusinessClassificationSelector implements IBusinessClassificationSelectorComponent {
  /**
   * Answer id
   */
  answerId: string;
  /**
   * Question id
   */
  questionId: string;
  /**
   * Question code
   */
  code: string;
  /**
   * Field type
   */
  fieldType: string;
  /***
   * Selected choice id
   */
  choiceId: string;
  /***
   * Choices to display
   */
  choices: IChoice[];
  /**
   * Selected answer choice, wrapped in an array
   */
  selectedChoices: IChoice[];
  /**
   * Placeholder to display
   */
  placeholder: string;
  /**
   * Is required
   */
  required: boolean;
  /**
   * Error messages
   */
  errors: string[] | undefined;
  /**
   * Error text
   */
  errorText: string | undefined;
  /**
   * Aria label id's that describes input for screen readers
   */
  labelId: string;
  /**
   * Show choices
   */
  showChoices: boolean;
  /**
   * Is touched
   */
  touched: boolean;
  /**
   * Is pristine
   */
  pristine: boolean;
  /**
   * Is answer in complete state
   */
  isCompleted: boolean;
  /**
   * When true, the field will be readonly. It will display only the label and value as plain text.
   */
  isReadOnly: boolean;
  /**
   * Label to use
   */
  label: string;
  /**
   *  Labels that describe group
   */
  labelledBy: string;
  /**
   * Should show Naics code
   */
  showNaicsCode: boolean;
  /**
   * Should show confidence
   */
  showConfidence: boolean;
  /**
   * Are nudges enabled for this tenant?
   */
  isRefilteringEnabled: boolean;
  /**
   * Help text
   */
  helpText: string;
  /**
   * Specifically how the question was answered (ie. "ACORD 126")
   */
  answeredBySource: string | undefined;
  useExternal: boolean;
  resetState(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  render(): any[];
  renderExternal(): any;
  renderInternal(): any;
}
